#include <bits/stdc++.h>
#define int long long
using namespace std;
int mx=0;
void f(string s,int cnt){
    for(int k=0;k<s.size();k++){
        if(s[k]=='?'){
            cnt--;

            if(cnt==0){
                s[k]='6';
                int br=0;
                for(int i=0;i<s.size();i++){
                    for(int j=i+1;j<s.size();j++){
                        if(s[i]=='6' and s[j]=='7')br++;
                    }
                }
                if(br>mx)cout<<s<<" "<<br<<endl,mx=br;
                s[k]='7';
                br=0;
                for(int i=0;i<s.size();i++){
                    for(int j=i+1;j<s.size();j++){
                        if(s[i]=='6' and s[j]=='7')br++;
                    }
                }
                if(br>mx)cout<<s<<" "<<br<<endl,mx=br;
            }
            else{
                s[k]='6';
                f(s,cnt);
                s[k]='7';
                f(s,cnt);
            }
        }
    }
}
// 67???67?76
signed main()
{
    int n,q;
    cin>>n>>q;
    string s;
    cin>>s;

    while(q--){
        int r,l;
        cin>>l>>r;
        int k=r-l+1;
        cout<<k/2*((k+1)/2)<<endl;
    }
    return 0;
}